#    Society Self-Service
#    Copyright © 2018  Yingtong Li (RunasSudo)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/>.

import markdown

from django.contrib.staticfiles.storage import staticfiles_storage

from django.conf import settings
from django.urls import reverse
from django.utils import timezone

from jinja2 import Environment, Markup

import importlib

def environment(**options):
	env = Environment(**options)
	env.globals.update({
		'import': importlib.import_module, # forgive me for I have sinned
		'localtime': lambda dt: timezone.localtime(dt).strftime('%Y-%m-%d %H:%M'),
		'settings': settings,
		'static': staticfiles_storage.url,
		'url': reverse,
		'MEDIA_URL': settings.MEDIA_URL,
	})
	env.filters.update({
		'markdown': lambda x: Markup(markdown.markdown(x))
	})
	return env
